%
% This function is part of the "rstab.m" package for generating alpha-stable
% variates.  See the help section of "rstab.m" for more references and details.
%
% *************************************************************************
% * IMPORTANT:
% The correction in Chambers, Mallows and Stuck JASA (1987) was
% incorporated.
% *************************************************************************
%
% Adapted from the FORTRAN code by D. Vandev <vandev@fmi.uni-sofia.bg>.
%


function y= d2(z)
%C
%C  EVALUATE (EXP(X)-1)/X
%C
%      DOUBLE PRECISION P1,P2,Q1,Q2,Q3,PV,ZZ
%C
%C  ON COMPILERS WITHOUT DOUBLE PRECISION THE ABOVE MUST BE
%C  REPLACED BY REAL P1,ETC.,AND THE DATA INITIALIZATION
%C  MUST    USE E RATHER THAN D FORMAT.
%C
%C  THE APPROXIMATION 1801 FROM HART ET.AL.(1968,P.213)
%C
 p=[840.066852536483239 20.0011141589964569];
 q=[1680.13370507296648 180.0133704073900023 0.1];
y=zeros(size(z));
I=find(abs(z)>0.1);
if ~isempty(I)
      y(I)=(exp(z(I))-1)./z(I);
end
I=find(abs(z)<=0.1);
if ~isempty(I)
    zz=z(I).*z(I);
    pv=p(1)+zz*p(2);
    y(I)=2*pv./(q(1)+zz.*(q(2)+zz*q(3))-z(I).*pv);
end


