%
% This function is part of the "rstab.m" package for generating alpha-stable
% variates.  See the help section of "rstab.m" for more references and details.
%
% Adapted from the FORTRAN code by D. Vandev <vandev@fmi.uni-sofia.bg>.
%
function y= tan2(x)
%      FUNCTION  TAN2(XARG)
%C
%C  COMPUTE TAN(XARG)/XARG
%C  ONLY FOR ABS(XARG).LE.PI BY 4
%C  FOR OTHER ARGUMENTS RETURNS TAN(X)/X COMPUTED DIRECTLY
%C
p=[.129221035E+3,-.887662377E+1,.528644456E-1];
q=[.164529332E+3,-.451320561E+2,1.];
pi4=pi/4;
xx=abs(x);
I=find(xx>pi4);
if ~isempty(I)
      y(I)=tan(x(I))./x(I);
end
I=find(xx<=pi4);
if ~isempty(I)
      xx=xx(I)./pi4;
      xx=xx.*xx;
      y(I)=(p(1)+xx.*(p(2)+xx*p(3)))...
	./(pi4*(q(1)+xx.*(q(2)+xx*q(3))));
end;
y=y';

